          LST OFF
****************************
*                          *
* MUSYS:                   *
* A MULTIUSER/MULTITASKING *
* ELKSYSTEM                *
*                          *
* (C) COPYRIGHT 1983 BY    *
* RICHARD SKRENTA          *
* ALL RIGHTS RESERVED      *
*                          *
* ------------------------ *
*                          *
* DEVICE DRIVERS AND       *
* USER FUNCTIONS           *
*                          *
****************************
JOBNO     EQU $00
PCOUNT    EQU $01
JOBPTR    EQU $02
INBUF     EQU $04
OUTBUF    EQU $06
PRSEBUF   EQU $08
SYSMEM    EQU $0A
JOBMEM    EQU $0C
LOMEM     EQU $0E
TEMP      EQU $10
*
REGS      EQU $45
X1        EQU $D0
X2        EQU $D2
X3        EQU $D4
X4        EQU $D6
X5        EQU $D8
X6        EQU $DA
X7        EQU $DC
X8        EQU $DE
PTR0      EQU $E0
PTR1      EQU $E2
PTR2      EQU $E4
PTR3      EQU $E6
PTR4      EQU $E8
T1        EQU $F0
T2        EQU $F2
T3        EQU $F4
T4        EQU $F6
T5        EQU $F8
T6        EQU $FA
T7        EQU $FC
T8        EQU $FE
*
JSTATUS   EQU 0
JPRIORTY  EQU 1
JPCOUNT   EQU 2
JECHO     EQU 3
JINDEV    EQU 4
JOUTDEV   EQU 5
JPROG     EQU 6
JREGS     EQU 8
JCCOUNT   EQU 13
JCTRLC    EQU 14
JINP1     EQU 16
JINP2     EQU 17
JOUTP1    EQU 18
JOUTP2    EQU 19
JPRSEP1   EQU 20
JPRSEP2   EQU 21
JNAME     EQU 22
JUSERID   EQU 30
JACCOUNT  EQU 38
JPROMPT   EQU 42
JPAUSE    EQU 54
JSUSP     EQU 55
JVAR      EQU 56
JINTX     EQU 105
JINTZ     EQU 107
JCOLUMN   EQU 109
JTIME     EQU 110
JPRMPT    EQU 116
JRUNSTAT  EQU 128
*
HOME      EQU $FC58
IOSAVE    EQU $FF4A
IOREST    EQU $FF3F
*
SYSRUN    EQU $300
SUBJOB    EQU SYSRUN+1
Q1        EQU SYSRUN+2
Q2        EQU SYSRUN+3
QS        EQU SYSRUN+4
QM        EQU SYSRUN+5
QH        EQU SYSRUN+6
QD        EQU SYSRUN+7
QMN       EQU SYSRUN+8
QY        EQU SYSRUN+9
K1        EQU SYSRUN+10
K2        EQU SYSRUN+11
MAXJOBS   EQU SYSRUN+18
SUBPROG   EQU SYSRUN+19
SYSLOG    EQU SYSRUN+20
SYSMDM    EQU SYSRUN+22
*
INIT      EQU $800
SETJOB    EQU INIT+3
CYCLE     EQU INIT+6
DOCYCLE   EQU INIT+9
PRTINC    EQU INIT+12
TIME      EQU INIT+15
IN        EQU INIT+18
OUT       EQU INIT+21
RESUME    EQU INIT+24
INTER     EQU INIT+27
PROMPT    EQU INIT+30
NAME      EQU INIT+33
READLN    EQU INIT+36
DELIM     EQU INIT+42
PARNUM    EQU INIT+45
LISTCMD   EQU INIT+48
PARSE     EQU INIT+51
CMD       EQU INIT+54
PROGRAM   EQU INIT+57
SLEEP     EQU INIT+60
TAB       EQU INIT+63
PRINT     EQU INIT+66
PUSH      EQU INIT+69
RESET     EQU INIT+72
PULL      EQU INIT+75
DECPRT    EQU INIT+78
DEC       EQU INIT+81
ZERO      EQU INIT+84
TIMPRT    EQU INIT+87
CREATE    EQU INIT+90
ATTACH    EQU INIT+93
SYSIO     EQU INIT+96
EXECX     EQU INIT+99
DAYPRT    EQU INIT+102
BEGIN     EQU INIT+105
KILL      EQU INIT+108
*
          ORG $900
DEVICE    JMP START
DEVIN0    JMP DEVIN
DEVOUT0   JMP DEVOUT
OPEN0     JMP OPEN
CLOSE0    JMP CLOSE
EXECY     JMP EXEC
DEVSTAT   DS 64
BUFP1     DS 17
BUFP2     DS 17
BUFSTART  DFB #<ENDPRG,#>ENDPRG
*
START     LDA #0
          STA LOMEM
          LDA BUFSTART+1
          CLC
          ADC #17
          STA LOMEM+1
*
          LDY #63
          LDA #0
START2    STA DEVSTAT,Y
          DEY
          BNE START2
*
          LDY #15
          LDA #0
START3    STA BUFP1,Y
          STA BUFP2,Y
          DEY
          BNE START3
          STA BUFP1
          STA BUFP2
          RTS
*
COUT      ORA #$80
          JSR $FDF0
          RTS
*
DEVIN     LDA #0
          BEQ DEV2
DEVOUT    STA T1
          LDA #1
          BNE DEV2
OPEN      LDA #2
          BNE DEV2
CLOSE     LDA #3
DEV2      STA T2
          STY T3
          TYA
          CMP #10
          BCS DEV3
          ASL
          TAY
          LDA DEVTBL,Y
          STA PTR1
          INY
          LDA DEVTBL,Y
          STA PTR1+1
          JMP (PTR1)
DEV3      CMP #$20
          BCS DEV4
          JMP BUFFER
DEV4      SEC
          RTS
DEVTBL    DFB #<NULLDEV,#>NULLDEV
          DFB #<CONSOLE,#>CONSOLE
          DFB #<PRINTER,#>PRINTER
          DFB #<MODEM,#>MODEM
          DFB #<NULLDEV,#>NULLDEV
          DFB #<NULLDEV,#>NULLDEV
          DFB #<NULLDEV,#>NULLDEV
          DFB #<NULLDEV,#>NULLDEV
          DFB #<NULLDEV,#>NULLDEV
          DFB #<NULLDEV,#>NULLDEV
          DFB #<NULLDEV,#>NULLDEV
          DFB #<NULLDEV,#>NULLDEV
          DFB #<NULLDEV,#>NULLDEV
          DFB #<NULLDEV,#>NULLDEV
          DFB #<NULLDEV,#>NULLDEV
          DFB #<NULLDEV,#>NULLDEV
CONSOLE   LDA T2
          BEQ KBDIN
          CMP #1
          BEQ SCRNOUT
          CMP #2
          BNE CONSOLE3
          LDY T3
          LDA DEVSTAT,Y
          BEQ CONSOLE2
          SEC
          RTS
CONSOLE3  LDY T3
          LDA #0
          STA DEVSTAT,Y
          CLC
          RTS
CONSOLE2  LDA JOBNO
          STA DEVSTAT,Y
          STA $C010
          CLC
          RTS
KBDIN     LDA #$DF
          JSR COUT
          LDA #$88
          JSR COUT
          LDA $C000
          BMI KBDIN2
          SEC
          RTS
KBDIN2    AND #$7F
          PHA
          LDA $C010
          LDA #$A0
          JSR COUT
          LDA #$88
          JSR COUT
          PLA
          CLC
          RTS
SCRNOUT   LDA T1
          AND #$7F
          CMP #10
          BEQ SCRNOUT3
          PHA
          LDA #' '
          JSR COUT
          LDA #$88
          JSR COUT
          PLA
          CMP #12
          BNE SCRNOUT2
          JSR HOME
SCRNOUT3  CLC
          RTS
SCRNOUT2  JSR COUT
          CLC
          RTS
NULLDEV   LDA T2
          BNE NULLDEV2
          SEC
          RTS
NULLDEV2  CLC
          RTS
PRINTER   LDA T2
          BNE PRIN2
PRIN4     SEC
          RTS
PRIN2     CMP #2
          BEQ PRIN3
          CMP #3
          BEQ PRIN5
          LDA $C1C1
          BMI PRIN4
          LDA T1
          STA $C090
          CLC
          RTS
PRIN3     LDY T3
          LDA DEVSTAT,Y
          BNE PRIN4
          LDA JOBNO
          STA DEVSTAT,Y
          CLC
          RTS
PRIN5     LDY T3
          LDA #0
          STA DEVSTAT,Y
          RTS
MODEM     LDX #$20
          LDA SYSMDM
          BEQ MODEM4
          LDA $C086,X
          CMP #8
          BCC MODEM4
          JSR PICKUP
          LDY #0
MODEM5    NOP
          NOP
          NOP
          DEY
          BNE MODEM5
          JSR PICKUP
          SEC
          RTS
MODEM4    LDA T2
          BEQ MDMIN
          CMP #1
          BEQ MDMOUT
          CMP #2
          BEQ MODEM2
          LDA #0
          LDY T3
          STA DEVSTAT,Y
          CLC
          RTS
MODEM2    LDY T3
          LDA DEVSTAT,Y
          BEQ MODEM3
          SEC
          RTS
MODEM3    LDA JOBNO
          STA DEVSTAT,Y
          CLC
          RTS
MDMIN     LDA SYSMDM
          BEQ MDMIN4
          LDA $C086,X
          AND #%00000101
          CMP #1
          BEQ MDMIN2
          SEC
          RTS
MDMIN2    LDA $C087,X
          AND #%01111111
          CLC
          RTS
MDMIN4    SEC
          RTS
MDMOUT    LDA SYSMDM
          BEQ MDMOUT3
          LDA $C086,X
          AND #%00000110
          CMP #2
          BEQ MDMOUT2
MDMOUT3   SEC
          RTS
MDMOUT2   LDA T1
          STA $C087,X
          CLC
          RTS
BUFFER    LDA T3
          SEC
          SBC #16
          STA T4
          LDA T2
          BEQ BUFIN
          CMP #1
          BEQ BUFOUT
          CMP #2
          BNE BUFFER2
          LDY #16
BUFFER5   LDA DEVSTAT,Y
          BEQ BUFFER3
          INY
          CPY #32
          BNE BUFFER5
          SEC
          RTS
BUFFER3   LDA JOBNO
          STA DEVSTAT,Y
          STY T3
          TYA
          SEC
          SBC #16
          STA T4
          JMP BUFFER4
BUFFER2   LDY T3
          LDA #0
          STA DEVSTAT,Y
BUFFER4   LDY T4
          LDA #0
          STA BUFP1,Y
          STA BUFP2,Y
          LDY T3
          CLC
          RTS
BUFIN     LDY T4
          LDA BUFP2,Y
          CMP BUFP1,Y
          BNE BUFIN2
          SEC
          RTS
BUFIN2    CLC
          ADC #1
          STA BUFP2,Y
          TAY
          DEY
          LDA BUFSTART
          STA PTR1
          LDA BUFSTART+1
          CLC
          ADC T4
          STA PTR1+1
          LDA (PTR1),Y
          CLC
          RTS
BUFOUT    LDY T4
          LDA BUFP1,Y
          CLC
          ADC #1
          CMP BUFP2,Y
          BNE BUFOUT2
          SEC
          RTS
BUFOUT2   STA BUFP1,Y
          TAY
          DEY
          LDA BUFSTART
          STA PTR1
          LDA BUFSTART+1
          CLC
          ADC T4
          STA PTR1+1
          LDA T1
          STA (PTR1),Y
          CLC
          RTS
************************
*                      *
*    USER FUNCTIONS    *
*                      *
************************
EXEC      JSR NAME
          ASC 'EXEC'
          DFB 0
          LDY #JCTRLC
          LDA #<EXEC
          STA (JOBPTR),Y
          INY
          LDA #>EXEC
          STA (JOBPTR),Y
          LDY #JPRMPT
          STY T1
          LDY #JPROMPT
          STY T2
EXEC2     LDY T1
          LDA (JOBPTR),Y
          LDY T2
          STA (JOBPTR),Y
          INC T1
          INY
          STY T2
          CPY #JPAUSE
          BNE EXEC2
          JSR READLN
          JSR CMD
          DFB #<KEYWORD,#>KEYWORD
          DFB #<ADDRESS,#>ADDRESS
          JSR PARSE
          JMP EXEC
KEYWORD   ASC 'SYSTAT'
          DFB 0
          ASC 'TEST'
          DFB 0
          ASC 'DAYTIME'
          DFB 0
          ASC 'PROMPT'
          DFB 0
          ASC 'HALT'
          DFB 0
          ASC 'LOGIN'
          DFB 0
          ASC 'KTIME'
          DFB 0
          ASC 'DATE'
          DFB 0
          ASC 'TIME'
          DFB 0
          ASC 'DO'
          DFB 0
          ASC 'PTYCON'
          DFB 0
          ASC 'LOGOUT'
          DFB 0
          ASC 'DUMP'
          DFB 0
          ASC 'WATCH'
          DFB 0
          ASC 'SHOW'
          DFB 0
          ASC 'CLOSE'
          DFB 0
          ASC 'DETACH'
          DFB 0
          ASC 'ATTACH'
          DFB 0
          ASC 'TERMINAL'
          DFB 0
          ASC 'OPR'
          DFB 0
          ASC 'SEND'
          DFB 0
          ASC 'PICKUP'
          DFB 0
          ASC 'HANGUP'
          DFB 0
          ASC 'MONITOR'
          DFB 0,0,0
ADDRESS   DFB #<SYSTAT,#>SYSTAT,70,0
          DFB #<TEST,#>TEST,50,0
          DFB #<DAYTIME,#>DAYTIME,70,0
          DFB #<CPROMPT,#>CPROMPT,50,0
          DFB #<HALT,#>HALT,1,0
          DFB #<LOGIN,#>LOGIN,70,0
          DFB #<KTIME,#>KTIME,2,0
          DFB #<SDATE,#>SDATE,70,0
          DFB #<STIME,#>STIME,70,0
          DFB #<DO,#>DO,50,0
          DFB #<PTYCON,#>PTYCON,2,0
          DFB #<LOGOUT,#>LOGOUT,70,0
          DFB #<DUMP,#>DUMP,10,0
          DFB #<WATCH,#>WATCH,5,0
          DFB #<SHOW,#>SHOW,50,0
          DFB #<ECLOSE,#>ECLOSE,50,0
          DFB #<DET,#>DET,50,0
          DFB #<CONNECT,#>CONNECT,70,0
          DFB #<TERMINAL,#>TERMINAL,50,0
          DFB #<OPR,#>OPR,2,0
          DFB #<SEND,#>SEND,50,0
          DFB #<PICKUP,#>PICKUP,2,0
          DFB #<HANGUP,#>HANGUP,50,0
          DFB #<MONITOR,#>MONITOR,1,0
TEST      LDA #0
          STA T6
          STA T6+1
          JSR NAME
          ASC 'TESTER'
          DFB 0
TEST3     JSR PRINT
          DFB $8D
          ASC 'MUSYS TESTER--LINE '
          DFB 0
          LDA T6
          STA T1
          LDA T6+1
          STA T1+1
          JSR DECPRT
          INC T6
          BNE TEST2
          INC T6+1
TEST2     JSR SLEEP
          JMP TEST3
SYSTAT    JSR NAME
          ASC 'SYSTAT'
          DFB 0
          JSR PRINT
          DFB $8D
          ASC 'SYSTEM JOB STATUS REPORT'
          DFB $8D
          ASC 'AT '
          DFB 0
          LDA #<QD
          LDY #>QD
          JSR DAYPRT
          LDA #<QS
          LDY #>QS
          JSR TIMPRT
          JSR PRINT
          DFB $8D,$8D
          ASC 'JOB  DEVICE   PROGRAM   USER'
          DFB $8D
          ASC '----------------------------'
          DFB $8D,0
          LDA JOBNO
          STA T6
          LDA #0
          STA T5
SYSTAT3   JSR SLEEP
          LDA T5
          STA JOBNO
          JSR SETJOB
          LDA JOBPTR
          STA PTR2
          LDA JOBPTR+1
          STA PTR2+1
          LDA T6
          STA JOBNO
          JSR SETJOB
          LDY #JSTATUS
          LDA (PTR2),Y
          BNE SYSTAT13
          JMP SYSTAT2
SYSTAT13  LDA T5
          CMP T6
          BNE SYSTAT8
          LDA #'*'
          JSR PUSH
          JMP SYSTAT9
SYSTAT8   LDA #' '
          JSR PUSH
SYSTAT9   LDA T5
          STA T1
          LDA #0
          STA T1+1
          JSR DECPRT
          LDA #5
          JSR TAB
          LDY #JINDEV
          LDA (PTR2),Y
          LDY #JOUTDEV
          ORA (PTR2),Y
          BEQ SYSTAT11
          LDA #'('
          JSR PUSH
          LDY #JINDEV
          LDA (PTR2),Y
          STA T1
          JSR DECPRT
          LDA #'/'
          JSR PUSH
          LDY #JOUTDEV
          LDA (PTR2),Y
          STA T1
          JSR DECPRT
          LDA #')'
          JSR PUSH
          JMP SYSTAT12
SYSTAT11  JSR PRINT
          ASC 'DET'
          DFB 0
SYSTAT12  LDA #14
          JSR TAB
          LDY #JNAME
          STY T1
SYSTAT5   LDY T1
          LDA (PTR2),Y
          BEQ SYSTAT4
          JSR PUSH
          INC T1
          JMP SYSTAT5
SYSTAT4   LDA #24
          JSR TAB
          LDY #JUSERID
          STY T1
SYSTAT7   LDY T1
          LDA (PTR2),Y
          BEQ SYSTAT6
          JSR PUSH
          INC T1
          LDA T1
          CMP #8
          BNE SYSTAT7
SYSTAT6   LDA #13
          JSR PUSH
SYSTAT2   LDA T5
          STA JOBNO
          JSR CYCLE
          LDA JOBNO
          BEQ SYSTAT10
          LDA JOBNO
          STA T5
          LDA T6
          STA JOBNO
          JSR SETJOB
          JMP SYSTAT3
SYSTAT10  LDA T6
          STA JOBNO
          JSR SETJOB
          LDA #13
          JSR PUSH
          RTS
DAYTIME   LDA #<QD
          LDY #>QD
          JSR DAYPRT
          LDA #<QS
          LDY #>QS
          JSR TIMPRT
          LDA #13
          JSR PUSH
          RTS
*
SDATE     LDY #JSTATUS
          LDA (JOBPTR),Y
          CMP #3
          BCS SDATE2
          JSR PARNUM
          BCS SDATE2
          LDA T3
          STA QD
          JSR PARNUM
          BCS SDATE2
          LDA T3
          STA QMN
          JSR PARNUM
          BCS SDATE2
          LDA T3
          STA QY
SDATE2    JSR PRINT
          ASC 'THE DATE IS '
          DFB 0
          LDA #<QD
          LDY #>QD
          JSR DAYPRT
          LDA #13
          JSR PUSH
          RTS
STIME     LDY #JSTATUS
          LDA (JOBPTR),Y
          CMP #3
          BCS STIME2
          JSR PARNUM
          BCS STIME2
          LDA #0
          STA QS
          STA QM
          STA QH
          LDA T3
          STA QH
          JSR PARNUM
          BCS STIME2
          LDA T3
          STA QM
          JSR PARNUM
          BCS STIME2
          LDA T3
          STA QS
STIME2    JSR PRINT
          ASC 'THE TIME IS '
          DFB 0
          LDA #<QS
          LDY #>QS
          JSR TIMPRT
          LDA #13
          JSR PUSH
          RTS
CPROMPT   LDY #JPRSEP1
          LDA (JOBPTR),Y
          STA T1
          LDY #JPRSEP2
          LDA (JOBPTR),Y
          STA T2
          LDY #JPRMPT
          STY T3
          LDY T2
          CPY T1
          BEQ CPROMPT2
          INC T2
CPROMPT3  LDY T2
          CPY T1
          BEQ CPROMPT2
          LDA (PRSEBUF),Y
          LDY T3
          STA (JOBPTR),Y
          INC T2
          INY
          CPY #JRUNSTAT-1
          BEQ CPROMPT2
          STY T3
          JMP CPROMPT3
CPROMPT2  LDY T3
          LDA #0
          STA (JOBPTR),Y
          RTS
HALT      LDY #JPROG
          LDA #<EXEC
          STA (JOBPTR),Y
          INY
          LDA #>EXEC
          STA (JOBPTR),Y
          JMP $FF69
LOGIN     LDY #JSTATUS
          LDA #2
          STA (JOBPTR),Y
          INY
          LDA #1
          STA (JOBPTR),Y
          LDY #JRUNSTAT
          LDA #%10000000
          STA (JOBPTR),Y
          LDY #JPRSEP1
          LDA (JOBPTR),Y
          STA T1
          LDY #JPRSEP2
          LDA (JOBPTR),Y
          STA T2
          LDY #JUSERID
          STY T3
          LDY T2
          CPY T1
          BEQ LOGIN2
          INC T2
LOGIN3    LDY T2
          CPY T1
          BEQ LOGIN2
          LDA (PRSEBUF),Y
          LDY T3
          STA (JOBPTR),Y
          INC T2
          INY
          CPY #JACCOUNT-1
          BEQ LOGIN2
          STY T3
          JMP LOGIN3
LOGIN2    LDY T3
          LDA #0
          STA (JOBPTR),Y
          RTS
KTIME     JSR PARNUM
          BCS KTIME2
          LDA T3
          STA K1
          JSR PARNUM
          BCS KTIME2
          LDA T3
          STA K2
KTIME2    JSR PRINT
          ASC 'CURRENT TIME CONSTANT IS: '
          DFB 0
          LDA #0
          STA T1+1
          LDA K1
          STA T1
          JSR DECPRT
          LDA #'/'
          JSR PUSH
          LDA K2
          STA T1
          JSR DECPRT
          LDA #13
          JSR PUSH
          RTS
DO        PLA
          PLA
          JSR NAME
          ASC 'DO'
          DFB 0
          LDA #0
          STA X4
          LDY #JCTRLC
          LDA #<DOERR
          STA (JOBPTR),Y
          INY
          LDA #>DOERR
          STA (JOBPTR),Y
          LDA #0
          STA X1
          LDY #JPRIORTY
          LDA (JOBPTR),Y
          STA X2
          LDY #JSTATUS
          LDA (JOBPTR),Y
          STA X3
DO2       JSR CMD
          DFB #<DOKEY,#>DOKEY
          DFB #<DOADR,#>DOADR
          JSR PARSE
          BCS DOEND
          JMP DO3
DOKEY     ASC 'OUTPUT'
          DFB 0
          ASC 'PRIORITY'
          DFB 0
          ASC 'STATUS'
          DFB 0,0,0
DOADR     DFB #<DOOUT,#>DOOUT,50,0
          DFB #<DOPRI,#>DOPRI,50,0
          DFB #<DOSTA,#>DOSTA,50,0
DOOUT     PLA
          PLA
          JSR PARDEV
          BCS DOEND
          LDY T3
          JSR OPEN
          BCC DOOUT2
          JSR PRINT
          ASC '?DEVICE NOT AVAILABLE'
          DFB $8D,0
DOEND     JMP DOERR
DOOUT2    STY X1
          JMP DO2
DOPRI     PLA
          PLA
          JSR PARNUM
          BCS DOEND
          LDA T3
          LDY #JPRIORTY
          CMP (JOBPTR),Y
          BCS DOPRI2
          JSR PRINT
          ASC '?INVALID PRIORITY'
          DFB $8D,0
DOEND2    JMP DOERR
DOPRI2    STA X2
          JMP DO2
DOSTA     PLA
          PLA
          JSR PARNUM
          BCS DOEND2
          LDA T3
          LDY #JSTATUS
          CMP (JOBPTR),Y
          BCS DOSTA2
          JSR PRINT
          ASC '?INVALID STATUS'
          DFB $8D,0
          JMP DOERR
DOSTA2    STA X3
          JMP DO2
DO3       LDY #16
          JSR OPEN
          BCC DO4
          JSR PRINT
          ASC '?NO FREE BUFFERS'
          DFB $8D,0
          JMP DOERR
DO4       STY X4
          STY T1
          LDA #0
          STA T1+1
          JSR PRINT
          DFB 91
          ASC 'PSEUDO-TERMINAL '
          DFB 0
          JSR DECPRT
          JSR PRINT
          ASC ' READY'
          DFB 93,$8D,0
          LDY #JINTZ
          LDA #<DO10
          STA (JOBPTR),Y
          INY
          LDA #>DO10
          STA (JOBPTR),Y
          JSR PRINT
          ASC 'ENTER TEXT, END WITH CTRL-Z'
          DFB $8D,0
          JSR PROMPT
          ASC '#'
          DFB 0
DO5       JSR READLN
          LDY #JPRSEP1
          LDA (JOBPTR),Y
          STA X5
          LDY #JPRSEP2
          LDA (JOBPTR),Y
          STA X6
DO7       LDY X6
          CPY X5
          BEQ DO8
          LDA (PRSEBUF),Y
          LDY X4
          JSR DEVOUT
          BCC DO6
DO9       JSR PRINT
          ASC '?BUFFER OVERFLOW'
          DFB $8D,0
          JMP DOERR
DO6       INC X6
          JMP DO7
DO8       LDA #13
          LDY X4
          JSR DEVOUT
          BCS DO9
          JMP DO5
DO10      LDA #%01000000
          JSR CREATE
          BCC DO11
          JSR PRINT
          ASC '?NO FREE JOB SLOTS'
          DFB $8D,0
          JMP DOERR
DO11      STA X8
          LDA JOBNO
          STA X7
          LDA X8
          STA JOBNO
          JSR SETJOB
          LDA JOBPTR
          STA PTR2
          LDA JOBPTR+1
          STA PTR2+1
          LDA X7
          STA JOBNO
          JSR SETJOB
          LDY #JSTATUS
          LDA X3
          STA (PTR2),Y
          INY
          LDA X2
          STA (PTR2),Y
          LDA X8
          LDX X4
          LDY X1
          JSR ATTACH
          LDA X8
          STA T1
          JSR PRINT
          DFB 91
          ASC 'JOB '
          DFB 0
          LDA #0
          STA T1+1
          JSR DECPRT
          JSR PRINT
          ASC ' QUEUED AT '
          DFB 0
          LDA #<QD
          LDY #>QD
          JSR DAYPRT
          LDA #<QS
          LDY #>QS
          JSR TIMPRT
          LDA #93
          JSR PUSH
          LDA #13
          JSR PUSH
          JMP DO12
DOERR     LDY X4
          JSR CLOSE
          LDY X1
          JSR CLOSE
DO12      LDA #0
          LDY #JINTZ
          STA (JOBPTR),Y
          INY
          STA (JOBPTR),Y
          JMP EXEC
PTYCON    JSR NAME
          ASC 'PTYCON'
          DFB 0
          JSR PROMPT
          ASC 'PTYCON>'
          DFB 0
          JSR READLN
          JSR CMD
          DFB #<PTYKEY,#>PTYKEY
          DFB #<PTYADR,#>PTYADR
          LDA JOBNO
          STA X1
          JSR PARSE
          JMP PTYCON
PTYKEY    ASC 'DEFINE'
          DFB 0
          ASC 'STATUS'
          DFB 0
          ASC 'PRIORITY'
          DFB 0
          ASC 'RUNSTATUS'
          DFB 0
          ASC 'KILL'
          DFB 0
          ASC 'SYSTAT'
          DFB 0
          ASC 'EXIT'
          DFB 0
          ASC 'CONNECT'
          DFB 0
          ASC 'OPEN'
          DFB 0,0,0
PTYADR    DFB #<PTYDEF,#>PTYDEF,5,0
          DFB #<PTYSTA,#>PTYSTA,5,0
          DFB #<PTYPRI,#>PTYPRI,5,0
          DFB #<PTYRUN,#>PTYRUN,5,0
          DFB #<PTYKIL,#>PTYKIL,5,0
          DFB #<SYSTAT,#>SYSTAT,5,0
          DFB #<PTYEXI,#>PTYEXI,5,0
          DFB #<PTYCNN,#>PTYCNN,5,0
          DFB #<PTYOPE,#>PTYOPE,5,0
PTYFIX    JSR PARNUM
          BCC PTYFIX2
          JSR PRINT
          ASC '?JOB NUMBER REQUIRED'
          DFB $8D,0
          PLA
          PLA
          RTS
PTYFIX2   LDA MAXJOBS
          CMP T3
          BCS PTYFIX3
          JSR PRINT
          ASC '?INVALID JOB NUMBER'
          DFB $8D,0
          PLA
          PLA
          RTS
PTYFIX3   LDA T3
          STA X2
          STA JOBNO
          JSR SETJOB
          LDA JOBPTR
          STA PTR2
          LDA JOBPTR+1
          STA PTR2+1
          LDA X1
          STA JOBNO
          JSR SETJOB
          RTS
PTYDEF    JSR PTYFIX
          LDY #0
          TYA
PTYDEF2   STA (PTR2),Y
          DEY
          BNE PTYDEF2
          LDY #JSTATUS
          LDA #60
          STA (PTR2),Y
          INY
          LDA #2
          STA (PTR2),Y
          LDY #JPROG
          LDA #<BEGIN
          STA (PTR2),Y
          INY
          LDA #>BEGIN
          STA (PTR2),Y
          LDY #JRUNSTAT
          LDA #%00100000
          STA (PTR2),Y
          LDY #JUSERID
PTYDEF3   LDA (JOBPTR),Y
          STA (PTR2),Y
          INY
          CPY #JPROMPT
          BNE PTYDEF3
          RTS
PTYSTA    JSR PTYFIX
          JSR PARNUM
          BCS PTYSTA3
          LDA T3
          BEQ PTYSTA2
          LDY #JSTATUS
          CMP (JOBPTR),Y
          BCS PTYSTA2
          JSR PRINT
          ASC '?INVALID STATUS'
          DFB $8D,0
          RTS
PTYSTA2   LDY #JSTATUS
          STA (PTR2),Y
          RTS
PTYSTA3   LDY #JSTATUS
          LDA (PTR2),Y
          STA T1
          LDA #0
          STA T1+1
          LDA #'='
          JSR PUSH
          JSR DECPRT
          LDA #13
          JSR PUSH
          RTS
PTYPRI    JSR PTYFIX
          JSR PARNUM
          BCS PTYPRI3
PTYPRI2   LDY #JPRIORTY
          LDA T3
          STA (PTR2),Y
          RTS
PTYPRI3   LDY #JPRIORTY
          LDA (PTR2),Y
          STA T1
          LDA #0
          STA T1+1
          LDA #'='
          JSR PUSH
          JSR DECPRT
          LDA #13
          JSR PUSH
          RTS
PTYRUN    JSR PTYFIX
          JSR PARNUM
          BCS PTYRUN2
          LDA T3
          LDY #JRUNSTAT
          STA (PTR2),Y
          RTS
PTYRUN2   LDY #JRUNSTAT
          LDA (PTR2),Y
          STA T1
          LDA #0
          STA T1+1
          LDA #'='
          JSR PUSH
          JSR DECPRT
          LDA #13
          JSR PUSH
          RTS
PTYKIL    JSR PTYFIX
          LDA T3
          JSR KILL
          RTS
PTYEXI    PLA
          PLA
          RTS
PTYCNN    JSR PTYFIX
          JSR PARNUM
          BCC PTYCNN2
PTYCNN3   JSR PRINT
          ASC '?ARGUMENT MISSING'
          DFB $8D,0
          RTS
PTYCNN2   LDA T3
          STA X1
          JSR PARNUM
          BCS PTYCNN3
          LDA T3
          STA X2
          LDY #JINDEV
          LDA X1
          STA (PTR2),Y
          LDY #JOUTDEV
          LDA X2
          STA (PTR2),Y
          RTS
PTYOPE    JSR PTYFIX
          JSR PARDEV
          BCC PTYOPE2
          JSR PRINT
          ASC '?DEVICE REQUIRED'
          DFB $8D,0
          RTS
PTYOPE2   LDY T3
          LDA X2
          STA DEVSTAT,Y
          RTS
DUALSET   LDX JOBNO
          STA JOBNO
          TXA
          PHA
          JSR SETJOB
          LDA JOBPTR
          STA PTR2
          LDA JOBPTR+1
          STA PTR2+1
          PLA
          STA JOBNO
          JSR SETJOB
          RTS
LOGOUT    JSR PARNUM
          BCC LOGOUT2
          LDA JOBNO
          JSR KILL
          JMP DIE
LOGOUT2   LDA T3
          STA X1
          JSR DUALSET
          LDY #JSTATUS
          LDA (PTR2),Y
          BNE LOGOUT7
          JSR PRINT
          ASC '?NONEXISTENT JOB'
          DFB $8D,0
LOGOUT7   LDY #JSTATUS
          LDA (JOBPTR),Y
          CMP #3
          BCC LOGOUT3
          LDA X1
          JSR USRCON
          BCS LOGOUT5
LOGOUT3   LDA T3
          JSR KILL
          RTS
LOGOUT5   JSR PRINT
          ASC '?WHEEL OR OPERATOR CAPABILITY REQUIRED'
          DFB $8D,0
          RTS
USRCON    STA X1
          JSR DUALSET
          LDY #JUSERID
          LDA (JOBPTR),Y
          CMP #'*'
          BEQ USRCON4
USRCON2   LDA (JOBPTR),Y
          BEQ USRCON3
          CMP (PTR2),Y
          BNE USRCON4
          INY
          CPY #JACCOUNT
          BNE USRCON2
USRCON3   CLC
          RTS
USRCON4   SEC
          RTS
DIE       JSR SLEEP
          JMP DIE
DUMP      JSR PARDEV
          BCC DUMP2
          JSR PRINT
          ASC '?ILLEGAL DEVICE'
          DFB $8D,0
          RTS
DUMP2     LDA T3
          STA X1
          JSR NAME
          ASC 'DUMP'
          DFB 0
DUMP5     LDA #10
          STA X2
DUMP4     LDY X1
          JSR DEVIN
          BCS DUMP3
          JSR PUSH
          DEC X2
          BNE DUMP4
DUMP3     JSR SLEEP
          JMP DUMP5
WATCH     JSR PARJOB
          LDA PTR2
          STA PTR3
          LDA PTR2+1
          CLC
          ADC #2
          STA PTR3+1
          JSR NAME
          ASC 'WATCH'
          DFB 0
          JSR PRINT
          ASC 'WATCH V1.0...USE <ESC> TO EXIT'
          DFB $8D,0
          LDY #JOUTP2
          LDA (PTR2),Y
          STA X2
WATCH5    LDY #JOUTP1
          LDA (PTR2),Y
          STA X1
          LDY X2
          CPY X1
          BEQ WATCH4
          LDA (PTR3),Y
          JSR PUSH
          INC X2
          JMP WATCH5
WATCH4    JSR SLEEP
          JSR PULL
          CMP #27
          BNE WATCH5
          LDA #13
          JSR PUSH
          RTS
SHOW      JSR NAME
          ASC 'SHOW'
          DFB 0
          JSR CMD
          DFB #<SHOKEY,#>SHOKEY
          DFB #<SHOADR,#>SHOADR
          JSR PARSE
          RTS
SHOKEY    ASC 'DEVICES'
          DFB 0
          ASC 'LOGINS'
          DFB 0,0,0
SHOADR    DFB #<SHODEV,#>SHODEV,50,0
          DFB #<SHOLOG,#>SHOLOG,50,0
*
SHODEV    JSR PRINT
          DFB $8D
          ASC 'DEVICE   NAME             USER'
          DFB $8D
          ASC '------------------------------'
          DFB $8D,0
          LDY #1
          STY X1
SHODEV4   LDY X1
          LDA DEVSTAT,Y
          BNE SHODEV5
          LDA X1
          CMP #4
          BCS SHODEV6
          LDA DEVSTAT,Y
SHODEV5   CMP JOBNO
          BNE SHODEV2
          LDA #'*'
          JSR PUSH
          JMP SHODEV3
SHODEV2   LDA #' '
          JSR PUSH
SHODEV3   LDA X1
          STA T1
          LDA #0
          STA T1+1
          JSR DECPRT
          LDA #9
          JSR TAB
          LDY X1
          JSR DEVPRT
          LDA #26
          JSR TAB
          LDY X1
          LDA DEVSTAT,Y
          BNE SHODEV7
          JSR PRINT
          DFB 91
          ASC 'FREE'
          DFB 93,0
          JMP SHODEV8
SHODEV7   STA T1
          LDA #0
          STA T1+1
          JSR DECPRT
SHODEV8   LDA #13
          JSR PUSH
SHODEV6   INC X1
          LDA X1
          CMP #64
          BCC SHODEV4
          LDA #13
          JSR PUSH
          CLC
          RTS
SHOLOG    LDA SYSLOG
          STA PTR4
          LDA SYSLOG+1
          STA PTR4+1
          LDY #0
          LDA (PTR4),Y
          BNE SHOLOG2
          JSR PRINT
          ASC 'NO LOGINS'
          DFB $8D,0
          RTS
SHOLOG2   JSR PRINT
          DFB $8D
          ASC 'LOGINS ARE ENABLED ON '
          DFB $8D,$8D,0
          LDY #0
          STY X1
SHOLOG3   LDY X1
          LDA (PTR4),Y
          BEQ SHOLOG4
          TAY
          JSR DEVPRT
          LDA #13
          JSR PUSH
          INC X1
          JMP SHOLOG3
SHOLOG4   LDA #13
          JSR PUSH
          CLC
          RTS
DEVPRT    CPY #1
          BEQ DEVPRT1
          CPY #2
          BEQ DEVPRT2
          CPY #3
          BEQ DEVPRT3
          CPY #32
          BCC DEVPRT16
          CPY #48
          BCC DEVPRT32
          CPY #64
          BCC DEVPRT64
          RTS
DEVPRT1   JSR PRINT
          ASC 'CONSOLE:'
          DFB 0
          RTS
DEVPRT2   JSR PRINT
          ASC 'PRINTER:'
          DFB 0
          RTS
DEVPRT3   JSR PRINT
          ASC 'MODEM:'
          DFB 0
          RTS
DEVPRT16  STY T1
          LDA #0
          STA T1+1
          JSR PRINT
          ASC 'BUFFER('
          DFB 0
          JSR DECPRT
          LDA #')'
          JSR PUSH
          RTS
DEVPRT32  STY T1
          LDA #0
          STA T1+1
          JSR PRINT
          ASC 'DRIVE1('
          DFB 0
          JSR DECPRT
          LDA #')'
          JSR PUSH
          RTS
DEVPRT64  STY T1
          LDA #0
          STA T1+1
          JSR PRINT
          ASC 'DRIVE2('
          DFB 0
          JSR DECPRT
          LDA #')'
          JSR PUSH
          RTS
ECLOSE    JSR PARDEV
          BCS ECLOSE2
          LDY #JSTATUS
          LDA (JOBPTR),Y
          CMP #3
          BCC ECLOSE3
          LDY T3
          LDA DEVSTAT,Y
          CMP JOBNO
          BEQ ECLOSE3
          JSR PRINT
          ASC '?WHEEL OR OPERATOR CAPABILITY REQUIRED'
          DFB $8D,0
          RTS
ECLOSE3   LDY T3
          JSR CLOSE
          RTS
ECLOSE2   LDY #63
          STY X1
ECLOSE5   LDY X1
          LDA DEVSTAT,Y
          CMP JOBNO
          BNE ECLOSE4
          JSR CLOSE
ECLOSE4   DEC X1
          BNE ECLOSE5
          LDY #JINDEV
          LDA (JOBPTR),Y
          TAY
          JSR OPEN
          LDY #JOUTDEV
          LDA (JOBPTR),Y
          TAY
          JSR OPEN
          RTS
DET       JSR PARJOB
          LDY #JSTATUS
          LDA (JOBPTR),Y
          CMP #3
          BCC DET4
          LDA T3
          JSR USRCON
          BCC DET4
          JSR PRINT
          ASC '?WHEEL OR OPERATOR CAPABILITY REQUIRED'
          DFB $8D,0
          RTS
DET4      LDA T3
          JSR DETACH
          RTS
DETACH    STA X1
          JSR DUALSET
          LDY #JSTATUS
          LDA (PTR2),Y
          BNE DETACH3
          JSR PRINT
          ASC '?NONEXISTEN JOB'
          DFB $8D,0
          RTS
DETACH3   LDA PTR2
          STA PTR3
          LDA PTR2+1
          STA PTR3+1
          LDY #JPROG
          LDA (PTR3),Y
          STA X2
          INY
          LDA (PTR3),Y
          STA X2+1
          LDY #JSTATUS
          LDA (PTR3),Y
          STA X3
          LDY #JRUNSTAT
          LDA (PTR3),Y
          STA X3+1
          LDA X1
          JSR KILL
DETACH2   JSR SLEEP
          LDY #JSTATUS
          LDA (PTR3),Y
          BNE DETACH2
          LDA X3
          STA (PTR3),Y
          LDY #JPROG
          LDA X2
          STA (PTR3),Y
          INY
          LDA X2+1
          STA (PTR3),Y
          LDY #JRUNSTAT
          LDA X3+1
          STA (PTR3),Y
          LDY #JINDEV
          LDA #0
          STA (PTR3),Y
          LDY #JOUTDEV
          STA (PTR3),Y
          RTS
CONNECT   JSR PARJOB
          LDA T3
          STA X1
          LDY #JSTATUS
          LDA (JOBPTR),Y
          CMP #3
          BCC CONNECT6
          LDA X1
          JSR USRCON
          BCC CONNECT6
          JSR PRINT
          ASC '?WHEEL OR OPERATOR CAPABILITY REQUIRED'
          DFB $8D,0
          RTS
CONNECT6  LDY #JSTATUS
          LDA (PTR2),Y
          CMP (JOBPTR),Y
          BCS CONNECT7
          JSR PRINT
          ASC '?OPERATOR CAPABILITY REQUIRED'
          DFB $8D,0
          RTS
CONNECT7  LDY #JINDEV
          LDA (PTR2),Y
          LDY #JOUTDEV
          ORA (PTR2),Y
          BEQ CONNECT2
          JSR PRINT
          ASC '?JOB NOT DETACHED'
          DFB $8D,0
          RTS
CONNECT2  LDA X1
          JSR DUALSET
          LDY #JINDEV
          LDA (JOBPTR),Y
          STA (PTR2),Y
          TAY
          LDA X1
          STA DEVSTAT,Y
          LDY #JINDEV
          LDA #0
          STA (JOBPTR),Y
          LDY #JOUTDEV
          LDA (JOBPTR),Y
          STA (PTR2),Y
          TAY
          LDA X1
          STA DEVSTAT,Y
          LDY #JOUTDEV
          LDA #0
          STA (JOBPTR),Y
          LDY #JCCOUNT
          LDA #1
          STA (PTR2),Y
          RTS
PARJOB    JSR PARNUM
          BCS PARJOB4
          LDA MAXJOBS
          CMP T3
          BCS PARJOB2
PARJOB4   JSR PRINT
          ASC '?JOB NUMBER REQUIRED'
          DFB $8D,0
PARJOB3   PLA
          PLA
          RTS
PARJOB2   LDA T3
          JSR DUALSET
          LDY #JSTATUS
          LDA (PTR2),Y
          BNE PARJOB5
          JSR PRINT
          ASC '?NONEXISTENT JOB'
          DFB $8D,0
          PLA
          PLA
          RTS
PARJOB5   RTS
PARDEV    JSR PARNUM
          BCS PARDEV2
          CLC
          RTS
PARDEV2   JSR CMD
          DFB #<DEVKEY,#>DEVKEY
          DFB #<DEVADR,#>DEVADR
          JSR PARSE
          SEC
          RTS
DEVKEY    ASC 'CONSOLE'
          DFB 0
          ASC 'PRINTER'
          DFB 0
          ASC 'MODEM'
          DFB 0
          ASC 'BUFFER'
          DFB 0,0,0
DEVADR    DFB #<DEVCON,#>DEVCON,50,0
          DFB #<DEVPTR,#>DEVPTR,50,0
          DFB #<DEVMDM,#>DEVMDM,50,0
          DFB #<DEVBUF,#>DEVBUF,50,0
DEVCON    LDA #1
          STA T3
          BNE PARDEV3
DEVPTR    LDA #2
          STA T3
          BNE PARDEV3
DEVMDM    LDA #3
          STA T3
          BNE PARDEV3
DEVBUF    JSR PARNUM
          BCC DEVBUF2
          LDA #16
          STA T3
DEVBUF2   JMP PARDEV3
PARDEV3   PLA
          PLA
          CLC
          RTS
TERMINAL  JSR CMD
          DFB #<TERMKEY,#>TERMKEY
          DFB #<TERMADR,#>TERMADR
          JSR PARSE
          RTS
TERMKEY   ASC 'FULL'
          DFB 0
          ASC 'HALF'
          DFB 0
          ASC 'OPERATOR'
          DFB 0,0,0
TERMADR   DFB #<TERME,#>TERME,50,0
          DFB #<TERMN,#>TERMN,50,0
          DFB #<TERMO,#>TERMO,255,0
TERME     LDY #JECHO
          LDA #0
          STA (JOBPTR),Y
          RTS
TERMN     LDY #JECHO
          LDA #1
          STA (JOBPTR),Y
          RTS
TERMO     JSR PRINT
          ASC 'PASSWORD:'
          DFB 0
          LDA #0
          STA X1
          STA X2
TERMO2    JSR SLEEP
          JSR PULL
          BCS TERMO2
          CMP #13
          BEQ TERMO3
          LDY X1
          CMP PASS,Y
          BEQ TERMO4
          LDA #1
          STA X2
TERMO4    INC X1
          JMP TERMO2
TERMO3    LDA X1
          BEQ TERMO5
          LDA X2
          BNE TERMO5
          LDY #JSTATUS
          LDA #1
          STA (JOBPTR),Y
          LDA #13
          JSR PUSH
          RTS
TERMO5    JSR PRINT
          DFB $8D
          ASC '?INVALID PASSWORD'
          DFB $8D,0
          RTS
PASS      ASC 'STICK'
          DFB 0
OPR       JSR PROMPT
          ASC 'OPR>'
          DFB 0
          JSR NAME
          ASC 'OPR'
          DFB 0
          JSR READLN
          JSR CMD
          DFB #<OPRKEY,#>OPRKEY
          DFB #<OPRADR,#>OPRADR
          JSR PARSE
          JMP OPR
OPRKEY    ASC 'SEND'
          DFB 0,0,0
OPRADR    DFB #<SEND,#>SEND,2,0
SEND      JSR PARJOB
          LDA T3
          STA X1
          JSR NAME
          ASC 'SEND'
          DFB 0
          JSR PRINT
          ASC 'ENTER LINE.  TERMINATE WITH <CR>'
          DFB $8D,0
          JSR PROMPT
          ASC '>'
          DFB 0
          JSR READLN
          LDY #JPRSEP1
          LDA (JOBPTR),Y
          CMP #128
          BCC SEND3
          JSR PRINT
          ASC '?LINE TOO LONG'
          DFB $8D,0
          RTS
SEND3     JSR PRINT
          ASC 'SENDING...'
          DFB $8D,0
          LDA X1
          JSR DUALSET
SEND2     JSR SLEEP
          LDY #JOUTP1
          LDA (PTR2),Y
          LDY #JOUTP2
          CMP (PTR2),Y
          BNE SEND2
          LDY #JPRSEP1
          LDA (JOBPTR),Y
          STA X3
          LDA PRSEBUF
          STA PTR4
          LDA PRSEBUF+1
          STA PTR4+1
          LDA JOBNO
          STA X2
          LDA X1
          STA JOBNO
          JSR SETJOB
          JSR PRINT
          ASC '*** JOB '
          DFB 0
          LDA X2
          STA T1
          LDA #0
          STA T1+1
          JSR DECPRT
          JSR PRINT
          ASC ' *** '
          DFB 0
          LDY #0
          STY X4
SEND4     LDY X4
          CPY X3
          BEQ SEND5
          LDA (PTR4),Y
          JSR PUSH
          INC X4
          JMP SEND4
SEND5     LDA X2
          STA JOBNO
          JSR SETJOB
          JSR PRINT
          ASC 'MESSAGE SENT'
          DFB $8D,0
          RTS
PICKUP    LDX #$20
          LDA #%10001011
          STA $C085,X
          LDA #3
          STA $C086,X
          LDA #0
          STA $C087,X
          LDA #1
          STA SYSMDM
          LDA #21
          STA $C086,X
          RTS
HANGUP    LDX #$20
          LDA #0
          STA $C085,X
          LDA #0
          STA SYSMDM
          RTS
MONITOR   LDA #12
          JSR PUSH
MONITOR2  LDA #0
          STA $24
          STA $25
          JSR SYSTAT
MONITOR3  JSR SLEEP
          LDY #JOUTP1
          LDA (JOBPTR),Y
          LDY #JOUTP2
          CMP (JOBPTR),Y
          BNE MONITOR3
          JSR -868
          JSR -958
          JSR SLEEP
          JMP MONITOR2
ENDPRG    DFB 0
